;https://www.chibiakumas.com/z80/platform6.php#LessonP58
	device zxspectrum48
	org $8000
begin
lmpr:          EQU  $FA
hmpr:          EQU  $FB
vmpr:          EQU  $FC
rom0_off:      EQU  %00100000
mode_4:        EQU  %01100000
base:          EQU  $F000

start:;         DI   
	ld a,%01101110; for mode4, value for mode3 01001110
	out (252),a ;VMPR - Video Memory Page Register
; Page in Vram
	ld a,%00101110 ;/R=ram in high area/B=low ram Bank
	out (250),a ;LMPR - Low Memory Page Register
	ld sp,$BFFF

;               IN   A,(lmpr)
;               LD   (v1+1),A
;
;
;               IN   A,(vmpr)
;               LD   (v2+1),A
;
;
;               AND  %00011111
;               OR   rom0_off
;               OUT  (lmpr),A
;
;               LD   HL,start
;               LD   DE,start-$8000
;
;               LD   BC,end-start
;               LDIR 
;
;               AND  %00011111
;               OUT  (hmpr),A
;
;
;
;               IN   A,(vmpr)
;               OR   mode_4
;               OUT  (vmpr),A
;
;               LD   A,3+rom0_off
;               OUT  (lmpr),A

;----------generate ^2--------------
sqrtab        EQU  $8200
	ld de,1
	ld hl,0;ld h,d,l,h
	push hl
	exx
	ld hl,sqrtab
	ld bc,sqrtab
	exx
gens:
	push hl
	exx
	pop de
	ld (hl),e:inc h
	ld (hl),d:dec h
	ld a,e
	ld (bc),a:inc b
	ld a,d
	ld (bc),a:dec b
	dec c
	inc l
	ld a,l
;	cp 129
	exx
;	jp z,nex_gen
	add hl,de
	inc de,de
	cp 129
	jr nz,gens
nex_gen:
;------------------------------------
 ;build
	pop hl
 ;              LD   HL,0000

               LD   B,$C0
ylp:           
               LD   C,0
xlp:           
               LD   (HL),0
               CALL getcol
               INC  C
;               XOR  A
               BIT  0,D
               JR   Z,next
;               LD   A,D
;               AND  $0F
               ADD  A,A
               ADD  A,A
               ADD  A,A
               ADD  A,A
put1:          
               LD   (HL),A


               CALL getcol
;               LD   A,D
;               AND  $0F

               OR   (HL)
               LD   (HL),A
next:          
               INC  HL
               INC  C
               JR   NZ,xlp
               DJNZ ylp


border:
               LD   BC,$01F8
wait1:         ;LD   A,1
               IN   A,(c);($F8)
               or a;CP   0
               JR   NZ,wait1

               LD   A,E
pal1:          
               OUT  (C),A
               INC  A
               INC  B
               BIT  4,B

               JR   Z,pal1
               DEC  E

	jr border
;------------------------------wait key
;wk:            
;               XOR  A
;               IN   A,(254)
;               CPL  
;               AND  31
;               JR   Z,border
;
;v1:            LD   A,0
;               OUT  (lmpr),A
;v2:            LD   A,0
;               OUT  (vmpr),A
;
;               EI   
;               RET  
getcol:        
               PUSH HL
               LD   H,sqrtab/256
               LD   A,C
               SUB  $80
               LD   L,A
               LD   E,(HL)
               INC  H
               LD   D,(HL)
               DEC  H

               LD   A,B
               SUB  $60
               LD   L,A
               LD   A,(HL)
               INC  H
               LD   H,(HL)
               DEC  H
               LD   L,A

               ADD  HL,DE
;              ADD  HL,HL
               EX   DE,HL
               POP  HL

               LD   A,D
               AND  $0F

               RET  

end
	display/d,end-begin
	savebin "oboi",begin,end-begin
;	shellexec "mgtman -wc test.dsk oboi 61440 61440"
	shellexec "mgtman -wc test.dsk oboi 32768 32768"